/* Szaszlyk: Grzegorz Matecki */
/* Rozwiazanie o zlozonosci: nk^3 */
#include <stdio.h>
#define MAXK 26


int n;	// rozmiar ciagu (szaszlyka)
int m;	// obliczenia mod m
int k;	// liczba roznych elementow ciagu

bool f2[MAXK][MAXK];		// zabronione pary
bool f3[MAXK][MAXK][MAXK];	// zabronione trojki

int tab[2][MAXK][MAXK];		// tablica do dynamicznych obliczen

int d;	// liczba zestawow testow

void readData()
{
	int f;			// liczba zabronionych fragmentow
	char forb[5];	// zabroniony fragment
	scanf("%d %d %d %d",&m,&n,&k,&f);
	for (int i=0;i<k;i++)
		for (int j=0;j<k;j++) {
			f2[i][j]=false;
			for (int l=0;l<k;l++) f3[i][j][l]=false;
		}
	for (int i=0;i<f;i++) {
		scanf("%s",forb);
		if (forb[2]==0) f2[forb[0]-'a'][forb[1]-'a']=true;	// para zabroniona
		else f3[forb[0]-'a'][forb[1]-'a'][forb[2]-'a']=true;	// trojka zabroniona
	}
} // readData

int solution()
{
	if (n==1) return k%m;
	int t=0;
	for (int i=0;i<k;i++)
		for(int j=0;j<k;j++) tab[t][i][j]=(f2[i][j])?0:1;
	while (n>2) {
		n--;
		t=1-t;
		for (int i=0;i<k;i++)
			for(int j=0;j<k;j++) {
				int x=0;
				if (!f2[i][j])
					for (int l=0;l<k;l++)
						if (!f3[l][i][j]) x+=tab[1-t][l][i];
				tab[t][i][j]=x%m;
			}
	}
	int sol=0;
	for (int i=0;i<k;i++)
		for(int j=0;j<k;j++) sol+=tab[t][i][j];
	return sol%m;
} // solution

int main()
{
	scanf("%d",&d);
	for (int i=0;i<d;i++) {
		readData();
		printf("%d\n",solution());
	}
	return 0;
}
